@echo off

SETLOCAL

call "%~dp0\vars.cmd"

set TOOLS_DIR=%PROJECT_DIR%\tools
set GNUWIN_DIR=%TOOLS_DIR%\gnuwin

if not exist "%TOOLS_DIR%" (
	echo The directory "%TOOLS_DIR%" not found
	exit /b 1
)

call "%~dp0\get_SchemaVersion.cmd" -

if /i %DBVer% equ 0 (
	call "%~dp0\create_OTaMan.cmd"
	exit /b
)

echo | set /p="set Product_DBVer=" > %TEMP%\getProduct_DBVer.cmd
"%GNUWIN_DIR%\grep" ");" "%~dp0\sql\tabledata\SchemaVersion.sql" | "%GNUWIN_DIR%\sed" -e "s/^.*(//;s/[ ]//g" | "%GNUWIN_DIR%\awk" -F"," "{print $1\"".\""$2\"".\""$3}" >> %TEMP%\getProduct_DBVer.cmd
call %TEMP%\getProduct_DBVer.cmd
del %TEMP%\getProduct_DBVer.cmd

set /a ExitStatus=0

if not "%Product_DBVer%" == "%DBVer%" (
	echo Update OTaMan database schema from version %DBVer% to %Product_DBVer%
	if "%sql_cmd%" == "" call "%~dp0\database_logon.cmd"

	set BAK_DIR_EXERCISE="%TMP%\OTaMan-exercises"
	set BAK_FILE_RESULTS="%TMP%\OTaMan-results.tsv"
	set BAK_FILE_SESSION="%TMP%\OTaMan-session.ini"

	echo | set /p="Backup exercises ... "
	mkdir "%BAK_DIR_EXERCISE%"
	del /f /q "%BAK_DIR_EXERCISE%"
	"%BINDIR%\DBConsoleTool.exe" export_exercise localhost OTaMan root "%sql_password%" "%BAK_DIR_EXERCISE%"
	if /i %ErrorLevel% equ 0 (
		echo Done
	) else (
		echo ERROR
		set /a ExitStatus=1
	)

	echo | set /p="Backup results ... "
	"%BINDIR%\DBConsoleTool.exe" export_result localhost OTaMan root "%sql_password%" "%BAK_FILE_RESULTS%"
	if /i %ErrorLevel% equ 0 (
		echo Done
	) else (
		echo ERROR
		set /a ExitStatus=1
	)

	echo | set /p="Backup session ... "
	"%BINDIR%\DBConsoleTool.exe" export_session localhost OTaMan root "%sql_password%" "%BAK_FILE_SESSION%"
	if /i %ErrorLevel% equ 0 (
		echo Done
	) else (
		echo ERROR
		set /a ExitStatus=1
	)

	echo | set /p="Install database schema ... "
	call "%~dp0\get_dump_OTaMan.cmd" | %sql_cmd%
	echo Done

	echo | set /p="Install templates ... "
	"%BINDIR%\DBConsoleTool.exe" insert_template localhost OTaMan root "%sql_password%" "%~dp0\templates"
	if /i %ErrorLevel% equ 0 (
		echo Done
	) else (
		echo ERROR
		set /a ExitStatus=1
	)

	echo | set /p="Restore exercises ... "
	"%BINDIR%\DBConsoleTool.exe" insert_exercise localhost OTaMan root "%sql_password%" "%BAK_DIR_EXERCISE%"
	if /i %ErrorLevel% equ 0 (
		echo Done
		del /f /q "%BAK_DIR_EXERCISE%"
		rmdir "%BAK_DIR_EXERCISE%"
	) else (
		echo ERROR
		set /a ExitStatus=1
	)

	echo | set /p="Restore results ... "
	"%BINDIR%\DBConsoleTool.exe" insert_result localhost OTaMan root "%sql_password%" "%BAK_DIR_RESULT%"
	if /i %ErrorLevel% equ 0 (
		echo Done
		del /f /q "%BAK_DIR_RESULT%"
		rmdir "%BAK_DIR_RESULT%"
	) else (
		echo ERROR
		set /a ExitStatus=1
	)

	echo | set /p="Restore session ... "
	"%BINDIR%\DBConsoleTool.exe" insert_session localhost OTaMan root "%sql_password%" "%BAK_FILE_SESSION%"
	if /i %ErrorLevel% equ 0 (
		echo Done
		del /f /q "%BAK_FILE_SESSION%"
	) else (
		echo ERROR
		set /a ExitStatus=1
	)
) else (
	echo Database schema OTaMan already has a version %Product_DBVer%. Update is not needed.
)

if /i %ExitStatus% equ 0 (
	timeout 3 2> nul
	if %ErrorLevel% neq 0 ping 127.0.0.1 -n 3 > nul
) else (
	pause
)

ENDLOCAL
